Index: en_US.ISO8859-1/articles/pam/Makefile
===================================================================
RCS file: /home/dcvs/doc/en_US.ISO8859-1/articles/pam/Makefile,v
retrieving revision 1.5
diff -d -u -I\$FreeBSD:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.5 Makefile
--- en_US.ISO8859-1/articles/pam/Makefile	16 Feb 2003 14:59:41 -0000	1.5
+++ en_US.ISO8859-1/articles/pam/Makefile	13 Apr 2003 18:44:47 -0000
@@ -9,6 +9,7 @@
 
 WITH_ARTICLE_TOC=YES
 WITH_INLINE_LEGALNOTICE=YES
+WITH_DOCFORMAT_NAVI_LINK=YES
 
 SRCS= article.sgml pam_app.c pam_conv.c pam_module.c
 
Index: en_US.ISO8859-1/share/sgml/catalog
===================================================================
RCS file: /home/dcvs/doc/en_US.ISO8859-1/share/sgml/catalog,v
retrieving revision 1.2
diff -d -u -I\$FreeBSD:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.2 catalog
--- en_US.ISO8859-1/share/sgml/catalog	21 Jun 2001 03:38:17 -0000	1.2
+++ en_US.ISO8859-1/share/sgml/catalog	13 Apr 2003 18:53:45 -0000
@@ -9,3 +9,6 @@
 
 PUBLIC "-//FreeBSD//ENTITIES DocBook Mailing List Entities//EN"
 	"mailing-lists.ent"
+
+PUBLIC "-//FreeBSD//ENTITIES DocBook Language Specific Entities//EN"
+	"l10n.ent"
Index: en_US.ISO8859-1/share/sgml/l10n.ent
===================================================================
RCS file: en_US.ISO8859-1/share/sgml/l10n.ent
diff -N en_US.ISO8859-1/share/sgml/l10n.ent
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ en_US.ISO8859-1/share/sgml/l10n.ent	13 Apr 2003 19:08:43 -0000
@@ -0,0 +1,9 @@
+<!-- -*- sgml -*-
+     DocBook Language Specific Entities for Localization.
+
+     $FreeBSD$
+-->
+
+<!-- docformat navi -->
+<!ENTITY docnavi.single-html "Single HTML">
+<!ENTITY docnavi.split-html  "Split HTML">
Index: ja_JP.eucJP/share/sgml/catalog
===================================================================
RCS file: /home/dcvs/doc/ja_JP.eucJP/share/sgml/catalog,v
retrieving revision 1.4
diff -d -u -I\$FreeBSD:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.4 catalog
--- ja_JP.eucJP/share/sgml/catalog	10 Aug 2002 20:48:37 -0000	1.4
+++ ja_JP.eucJP/share/sgml/catalog	13 Apr 2003 19:04:51 -0000
@@ -10,6 +10,9 @@
 PUBLIC "-//FreeBSD//ENTITIES DocBook Mailing List Entities//JA"
 	"mailing-lists.ent"
 
+PUBLIC "-//FreeBSD//ENTITIES DocBook Language Specific Entities//EN"
+	"l10n.ent"
+
 PUBLIC  "-//FreeBSD//ENTITIES DocBook Author Entities//JA"
         "authors.ent"
 
Index: ja_JP.eucJP/share/sgml/l10n.ent
===================================================================
RCS file: ja_JP.eucJP/share/sgml/l10n.ent
diff -N ja_JP.eucJP/share/sgml/l10n.ent
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ ja_JP.eucJP/share/sgml/l10n.ent	13 Apr 2003 19:08:30 -0000
@@ -0,0 +1,9 @@
+<!-- -*- sgml -*-
+     DocBook Language Specific Entities for Localization.
+
+     $FreeBSD$
+-->
+
+<!-- docformat navi -->
+<!ENTITY docnavi.single-html "ñ">
+<!ENTITY docnavi.split-html  "ʬ">
Index: share/misc/docbook.css
===================================================================
RCS file: /home/dcvs/doc/share/misc/docbook.css,v
retrieving revision 1.4
diff -d -u -I\$FreeBSD:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.4 docbook.css
--- share/misc/docbook.css	11 Jul 2001 12:46:50 -0000	1.4
+++ share/misc/docbook.css	13 Apr 2003 18:39:52 -0000
@@ -159,3 +159,7 @@
 	background-color: #F0F0F0;
 	text-decoration: underline;
 } 
+
+.PROGRAMLISTING, .SCREEN {
+	margin-left: 3ex;
+}
Index: share/mk/doc.docbook.mk
===================================================================
RCS file: /home/dcvs/doc/share/mk/doc.docbook.mk,v
retrieving revision 1.81
diff -d -u -I\$FreeBSD:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.81 doc.docbook.mk
--- share/mk/doc.docbook.mk	11 Apr 2003 09:21:15 -0000	1.81
+++ share/mk/doc.docbook.mk	13 Apr 2003 18:39:52 -0000
@@ -203,6 +203,9 @@
 HTMLFLAGS+=	-V biblio-xref-title
 PRINTFLAGS+=	-V biblio-xref-title
 .endif
+.if defined(WITH_DOCFORMAT_NAVI_LINK) && !empty(WITH_DOCFORMAT_NAVI_LINK)
+HTMLFLAGS+=	-V %generate-docformat-navi-link%
+.endif
 
 PERL?=		/usr/bin/perl
 PKG_CREATE?=	/usr/sbin/pkg_create
Index: share/sgml/catalog
===================================================================
RCS file: /home/dcvs/doc/share/sgml/catalog,v
retrieving revision 1.26
diff -d -u -I\$FreeBSD:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.26 catalog
--- share/sgml/catalog	31 Oct 2002 20:21:01 -0000	1.26
+++ share/sgml/catalog	13 Apr 2003 19:26:40 -0000
@@ -29,6 +29,9 @@
 PUBLIC	"-//FreeBSD//ENTITIES DocBook Miscellaneous FreeBSD Entities//EN"
 	"freebsd.ent"
 
+PUBLIC "-//FreeBSD//ENTITIES DocBook Language Specific Entities//EN"
+	"l10n.ent"
+
   -- ...................................................................... --
   -- English specific ..................................................... --
 
Index: share/sgml/freebsd.dsl
===================================================================
RCS file: /home/dcvs/doc/share/sgml/freebsd.dsl,v
retrieving revision 1.69
diff -d -u -I\$FreeBSD:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.69 freebsd.dsl
--- share/sgml/freebsd.dsl	16 Feb 2003 14:59:30 -0000	1.69
+++ share/sgml/freebsd.dsl	13 Apr 2003 19:03:32 -0000
@@ -8,6 +8,9 @@
 <!ENTITY % output.print.justify	"IGNORE">
 <!ENTITY % output.print.twoside	"IGNORE">
 
+<!ENTITY % freebsd.l10n PUBLIC "-//FreeBSD//ENTITIES DocBook Language Specific Entities//EN">
+%freebsd.l10n;
+
 <![ %output.html; [
 <!ENTITY docbook.dsl PUBLIC "-//Norman Walsh//DOCUMENT DocBook HTML Stylesheet//EN" CDATA DSSSL>
 ]]>
@@ -62,6 +65,10 @@
           ;; HTML file.
           #f)
 
+        (define %generate-docformat-navi-link%
+          ;; Create docformat navi link for HTML output?
+          #f)
+
         (define (book-titlepage-recto-elements)
           (list (normalize "title")
                 (normalize "subtitle")
@@ -76,6 +83,59 @@
                 (normalize "legalnotice")
                 (normalize "isbn")))
 
+        ;; Create a simple navigation link
+        ;; if %generate-docformat-navi-link% defined.
+        (define (make-docformat-navi tlist)
+          (let ((rootgi (gi (sgml-root-element))))
+            (make element gi: "DIV"
+                  attributes: '(("CLASS" "DOCFORAMTNAVI"))
+                  (literal "[ ")
+                  (make-docformat-navi-link rootgi tlist)
+                  (literal " ]"))))
+
+        (define (make-docformat-navi-link rootgi tlist)
+          (make sequence
+            (cond
+             ((null? tlist)               (empty-sosofo))
+             ((null? (car tlist))         (empty-sosofo))
+             ((not (symbol? (car tlist))) (empty-sosofo))
+             ((equal? (car tlist) 'html-split)
+              (make sequence
+                (create-link (list (list "href" "./index.html"))
+                             (literal "&docnavi.split-html;"))
+                (if (not (null? (cdr tlist)))
+                    (make sequence
+                      (literal " / ")
+                      (make-docformat-navi-link rootgi (cdr tlist)))
+                    (empty-sosofo))))
+             ((equal? (car tlist) 'html-single)
+              (make sequence
+                (create-link (list (list "href"
+                                         (string-append "./" (case-fold-down rootgi) ".html")))
+                             (literal "&docnavi.single-html;"))
+                (if (not (null? (cdr tlist)))
+                    (make sequence
+                      (literal " / ")
+                      (make-docformat-navi-link rootgi (cdr tlist)))
+                    (empty-sosofo))))
+             (else (empty-sosofo)))))
+
+        (define (article-titlepage-separator side)
+          (make sequence
+            (if %generate-docformat-navi-link%
+                (make-docformat-navi '(html-split html-single))
+                (empty-sosofo))
+            (make empty-element gi: "HR")))
+
+        (define (book-titlepage-separator side)
+          (if (equal? side 'recto)
+              (make sequence
+                (if %generate-docformat-navi-link%
+                    (make-docformat-navi '(html-split html-single))
+                    (empty-sosofo)) 
+                (make empty-element gi: "HR"))
+              (empty-sosofo)))
+
         <!-- This is the text to display at the bottom of each page.
              Defaults to nothing.  The individual stylesheets should
              redefine this as necessary. -->
@@ -601,10 +661,10 @@
         #f)
       
       (define %indent-programlisting-lines%
-        "    ")
+        #f)
  
       (define %indent-screen-lines%
-        "    ")
+        #f)
 
       (define (article-titlepage-recto-elements)
         (list (normalize "title")
Index: share/sgml/l10n.ent
===================================================================
RCS file: share/sgml/l10n.ent
diff -N share/sgml/l10n.ent
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ share/sgml/l10n.ent	13 Apr 2003 19:08:43 -0000
@@ -0,0 +1,9 @@
+<!-- -*- sgml -*-
+     DocBook Language Specific Entities for Localization.
+
+     $FreeBSD$
+-->
+
+<!-- docformat navi -->
+<!ENTITY docnavi.single-html "Single HTML">
+<!ENTITY docnavi.split-html  "Split HTML">
